; 
    .586                       ; create 32 bit code
    .model flat, stdcall       ; 32 bit memory model
    option casemap :none       ; case sensitive
 
    include \masm32\include\windows.inc
    include \masm32\include\masm32.inc
    include \masm32\include\kernel32.inc
    includelib \masm32\lib\masm32.lib
    includelib \masm32\lib\kernel32.lib
    include \masm32\macros\macros.asm
    include timers.asm

    showlen MACRO    
      print chr$("  buffer1 length:")
      invoke szLen,ADDR buffer1
      print ustr$(eax)
      print chr$(9)
    ENDM
  
    _TrimLeadingSpaces PROTO :DWORD
    TrimLeadingSpaces PROTO :DWORD

    TrimLe PROTO :DWORD

    block_ltrim PROTO :DWORD
    _block_ltrim PROTO :DWORD

    _szCopy PROTO :DWORD,:DWORD
; 
    .data
      ovrhead dd 0      
      buffer0 db 9,9,"                         I'm Larry,",13,10,\
                 9,32,9,32,9," this is my brother darryl,",13,10,\
                 " and this is my other brother darryl.",13,10,0
      buffer1 db LENGTHOF buffer0 dup(0)
      pad     dd 0
    .code
; 
start: 
; 

    invoke szCopy,ADDR buffer0,ADDR buffer1
    print ADDR buffer1
    print chr$("  _TrimLeadingSpaces:",13,10)
    invoke _TrimLeadingSpaces,ADDR buffer1
    print ADDR buffer1

    showlen

    invoke szCopy,ADDR buffer0,ADDR buffer1
    print chr$("  TrimLeadingSpaces:",13,10)
    invoke TrimLeadingSpaces,ADDR buffer1
    print ADDR buffer1

    showlen

    invoke szCopy,ADDR buffer0,ADDR buffer1
    print chr$("  TrimLe:",13,10)
    invoke TrimLe,ADDR buffer1
    print ADDR buffer1

    showlen

    invoke szCopy,ADDR buffer0,ADDR buffer1
    print chr$("  block_ltrim:",13,10)
    invoke block_ltrim,ADDR buffer1
    print ADDR buffer1

    showlen

    invoke szCopy,ADDR buffer0,ADDR buffer1
    print chr$("  _block_ltrim:",13,10)
    invoke _block_ltrim,ADDR buffer1
    print ADDR buffer1

    showlen
    mov   eax,input(13,10,"Press enter to continue...",13,10)

    LOOPCOUNT EQU 1000000
    counter_begin LOOPCOUNT,REALTIME_PRIORITY_CLASS
      invoke szCopy,ADDR buffer0,ADDR buffer1
    counter_end
    mov   ovrhead,eax

    print chr$("_TrimLeadingSpaces: ")
    counter_begin LOOPCOUNT,REALTIME_PRIORITY_CLASS
      invoke szCopy,ADDR buffer0,ADDR buffer1
      invoke _TrimLeadingSpaces,ADDR buffer1
    counter_end
    sub   eax,ovrhead
    print ustr$(eax)
    print chr$(" cycles",13,10,"TrimLeadingSpaces: ")

    counter_begin LOOPCOUNT,REALTIME_PRIORITY_CLASS
      invoke szCopy,ADDR buffer0,ADDR buffer1
      invoke TrimLeadingSpaces,ADDR buffer1
    counter_end
    sub   eax,ovrhead
    print ustr$(eax)
    print chr$(" cycles",13,10,"TrimLe: ")

    counter_begin LOOPCOUNT,REALTIME_PRIORITY_CLASS
      invoke szCopy,ADDR buffer0,ADDR buffer1
      invoke TrimLe,ADDR buffer1
    counter_end
    sub   eax,ovrhead
    print ustr$(eax)
    print chr$(" cycles",13,10,"block_ltrim: ")

    counter_begin LOOPCOUNT,REALTIME_PRIORITY_CLASS
      invoke szCopy,ADDR buffer0,ADDR buffer1
      invoke block_ltrim,ADDR buffer1
    counter_end
    sub   eax,ovrhead
    print ustr$(eax)
    print chr$(" cycles",13,10,"_block_ltrim: ")

    counter_begin LOOPCOUNT,REALTIME_PRIORITY_CLASS
      invoke szCopy,ADDR buffer0,ADDR buffer1
      invoke _block_ltrim,ADDR buffer1
    counter_end
    sub   eax,ovrhead
    print ustr$(eax)
    print chr$(" cycles",13,10)

    mov   eax,input(13,10,"Press enter to exit...")
    exit

; 
_TrimLeadingSpaces PROC USES EDI ESI LpBuffer:DWORD
    mov   esi,LpBuffer
    mov   edi,esi               ; Use the supplied buffer
                                ; to condense the text
    ;check start of line
    ALIGN 4
  linestart:
    ;lodsb
    lob           ; MASM32 macro, fast replacement for lodsb
    cmp   al,20h                ;space?
    jz    linestart
    cmp   al,9                  ;tab?
    jz    linestart

    ;find crlf or end of text
   @@:
    ;stosb
    stb           ; MASM32 macro, fast replacement for stosb
    or    al,al                 ;end of string?
    jz    done
    .if   al == 10              ;lf?
      .if byte ptr[esi+1] == 13 ;cr? 
        ;movsb                   ;(this is a precaution
                                ;against a reversal of the
                                ;crlf bytes by some editors)
        mov   al,[esi]          ;
        add   esi,1             ; No significant benefit
        mov   [edi],al          ; for P3
        add   edi,1             ;

      .endif
      jmp   linestart
    .endif
    ;lodsb
    lob           ; MASM32 macro, fast replacement for lodsb
    jmp   @B
  done:
    ret
_TrimLeadingSpaces endp    

; 

ALIGN 4
TrimLeadingSpaces PROC USES EBX EDI ESI LpBuffer:DWORD
    LOCAL LinBuffer[512]:BYTE ; A buffer to hold a line of text
                              ; to parse
    mov ebx, LpBuffer
    lea edi, LinBuffer
    mov edx, ebx              ; edx holds the starting position in the
    xor esi, esi              ; buffer to put the parsed text at.
    ALIGN 4
  GetLine:
    mov al, [ebx]             ; move characters from input buffer to the
    mov [edi + esi], al       ; LinBuffer until a LF or end of buffer
    add ebx, 1                ; is found.
    add esi, 1
    test al, al               ; at end of buffer?
    jnz NotEnd
    jmp over
  NotEnd:
    cmp al, 10                ; at end of line?
    jne GetLine
  over:
    xor esi, esi
    sub esi, 1
  ParseBuff:
    add esi ,1
    mov al, [edi + esi]
    cmp al, 32                ; is the char a space?
    ja DoneParse              ; Done is char is a num,letter,or punctuaton
    je ParseBuff              ; get next char if a space
    cmp al, 9                 ; is the char a tab?
    je ParseBuff              ; get next char if a tab
  DoneParse:
    mov ecx, edi              ; get start offset in LinBuff
    add ecx , esi
    xor esi, esi
  MoveBuff:
    mov al, [ecx + esi]       ; put the line back into the input buffer,
    mov [edx], al             ; minus the leading tabs and spaces.
    add edx, 1
    add esi,1
    test al,al                ; are we at the end of input?
    jz Done
    cmp al, 10                ; are we at end of line?
    jne MoveBuff
    xor esi, esi
    jmp GetLine
  Done:
    ret
TrimLeadingSpaces endp

; 

align 4

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

block_ltrim proc src:DWORD

    mov edx, [esp+4]
    mov ecx, [esp+4]
    sub edx, 1
    jmp trimleft

  align 4
  trimleft:
    add edx, 1
    cmp BYTE PTR [edx], 32
    je trimleft
    cmp BYTE PTR [edx], 9
    je trimleft
    jmp nxt

  align 4
  store:
    add edx, 1
  nxt:
    mov al, [edx]
    mov [ecx], al
    add ecx, 1
    test al, al             ; test for written terminator
    jz bl_out    
    sub al, 10              ; test for ascii 10
    jnz store
    jmp trimleft

  bl_out:

    ret 4

block_ltrim endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 

align 4

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

_block_ltrim proc src:DWORD

    mov edx, [esp+4]
    mov ecx, [esp+4]
    sub edx, 1
    jmp trimleft

  align 4
  trimleft:
    add edx, 1
    cmp BYTE PTR [edx], 32
    je trimleft
    cmp BYTE PTR [edx], 9
    je trimleft
    jmp nxt

  align 4
  store:
    add edx, 1
  nxt:
    mov al, [edx]
    mov [ecx], al
    add ecx, 1
    test al, al             ; test for written terminator
    jz bl_out    
    sub al, 10              ; test for ascii 10
    jnz store
    jmp trimleft

  bl_out:

    ret 4

_block_ltrim endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; 
; Local copy of szCopy included to determine if the higher cycle
; count for _block_ltrim was due to some caching effect.
; 
align 4

OPTION PROLOGUE:NONE 
OPTION EPILOGUE:NONE 

comment * -----------------------------------------------
        copied length minus terminator is returned in EAX
        ----------------------------------------------- *
align 16

_szCopy proc src:DWORD,dst:DWORD

    push ebp

    mov edx, [esp+8]
    mov ebp, [esp+12]
    xor ecx, ecx        ; ensure no previous content in ECX
    mov eax, -1

  @@:
    add eax, 1
    mov cl, [edx+eax]
    mov [ebp+eax], cl
    test cl, cl
    jnz @B

    pop ebp

    ret 8

_szCopy endp

OPTION PROLOGUE:PrologueDef 
OPTION EPILOGUE:EpilogueDef 

; 

OPTION  PROLOGUE:NONE       ;turn it off
OPTION  EPILOGUE:NONE
Align 16
db 8Dh,0A4h,24h,0,0,0,0,8Dh,64h,24h,0
TrimLe  PROC  lapBuffer:DWORD
    mov   eax,[esp]         ;eax->return address
    mov   ecx,[esp+4]       ;ecx->lpBuffer parameter
    mov   [esp],ebx         ;save ebx register
    mov   [esp+4],eax       ;save return address
    mov   ebx,1             ;ebx = 1
    mov   edx,ecx           ;edx = ecx->lpBuffer parameter
NewLine:
    mov   al,[ecx]
    add   ecx,ebx
ZeroTest:
    test  al,al
    je    Ende
    cmp   al,9
    je    NewLine
    cmp   al,20h
    je    NewLine
    mov   [edx],al
    add   edx,ebx
CopyText:
    mov   al,[ecx]
    add   ecx,ebx
    mov   [edx],al
    add   edx,ebx
    cmp   al,0Ah
    jg    CopyText
    mov   al,[ecx]
    jne   Ende
    add   ecx,ebx
    cmp   al,0Dh
    jne   ZeroTest
    mov   [edx],al
    add   edx,ebx
    jno   NewLine
Ende:
    mov   ebx,[esp]           ;restore ebx register
    add   esp,4
    mov   byte ptr[edx],0
    ret                       ;should be faster than ret 4
TrimLe  ENDP
OPTION  PROLOGUE:PROLOGUEDEF  ;turn back on the defaults
OPTION  EPILOGUE:EPILOGUEDEF

; 

end start
